using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Microsoft.ApplicationBlocks.ExceptionManagement;

namespace Photo_Editor_Application
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class PhotoEditorForm : System.Windows.Forms.Form
	{
        private System.Windows.Forms.MainMenu MainMenu;
        private System.Windows.Forms.MenuItem FileMenu;
        private System.Windows.Forms.MenuItem OpenFile;
        
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
        /// <summary>
        /// Holds a custom scrollable control object.
        /// </summary>
        public CustomScrollableControl.CustomScrollableControl customScrollableControl;
        private System.Windows.Forms.TabControl tabControl;
        private System.Windows.Forms.TabPage basicImageOperations;
        private System.Windows.Forms.Button cropImageButton;
        private System.Windows.Forms.Button flipVerticalButton;
        private System.Windows.Forms.Button flipHorizontalButton;
        private System.Windows.Forms.Button rotateClockButton;
        private System.Windows.Forms.Button rotateCClockButton;
        private System.Windows.Forms.MenuItem saveMenu;

        // Get the directory in which the application was started.
        private static string applicationDirectory = Application.StartupPath;
        
        /// <summary>
        /// Accessor to the Application directory.
        /// </summary>
        public static string GetApplicationDirectory
        {
            get
            {
                return applicationDirectory;
            }
        }
        /// <summary>
        /// Holds a Picture Object.
        /// </summary>
        public Picture PictureObject;
        /// <summary>
        /// Constructor.
        /// </summary>
		public PhotoEditorForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
            
            PictureObject = new Picture();
            
		}
        /// <summary>
        /// Custom paint method.
        /// </summary>
        protected override void OnPaint(PaintEventArgs e)
        {
            try
            {
                Graphics deviceContext = e.Graphics;
          
            }
            catch(Exception exception)
            {
                ExceptionManager.Publish(exception);
            }
        } 

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(PhotoEditorForm));
            this.MainMenu = new System.Windows.Forms.MainMenu();
            this.FileMenu = new System.Windows.Forms.MenuItem();
            this.OpenFile = new System.Windows.Forms.MenuItem();
            this.saveMenu = new System.Windows.Forms.MenuItem();
            this.customScrollableControl = new CustomScrollableControl.CustomScrollableControl();
            this.tabControl = new System.Windows.Forms.TabControl();
            this.basicImageOperations = new System.Windows.Forms.TabPage();
            this.rotateCClockButton = new System.Windows.Forms.Button();
            this.flipHorizontalButton = new System.Windows.Forms.Button();
            this.rotateClockButton = new System.Windows.Forms.Button();
            this.flipVerticalButton = new System.Windows.Forms.Button();
            this.cropImageButton = new System.Windows.Forms.Button();
            this.tabControl.SuspendLayout();
            this.basicImageOperations.SuspendLayout();
            this.SuspendLayout();
            // 
            // MainMenu
            // 
            this.MainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                     this.FileMenu});
            // 
            // FileMenu
            // 
            this.FileMenu.Index = 0;
            this.FileMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                     this.OpenFile,
                                                                                     this.saveMenu});
            this.FileMenu.Text = "&File";
            // 
            // OpenFile
            // 
            this.OpenFile.Index = 0;
            this.OpenFile.Text = "&Open File";
            this.OpenFile.Click += new System.EventHandler(this.OpenFile_Click);
            // 
            // saveMenu
            // 
            this.saveMenu.Index = 1;
            this.saveMenu.Text = "&Save as ...";
            this.saveMenu.Click += new System.EventHandler(this.saveMenu_Click);
            // 
            // customScrollableControl
            // 
            this.customScrollableControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.customScrollableControl.Location = new System.Drawing.Point(0, 0);
            this.customScrollableControl.Name = "customScrollableControl";
            this.customScrollableControl.ScrollingImage = null;
            this.customScrollableControl.ScrollingImageArea = new System.Drawing.Rectangle(0, 0, 824, 460);
            this.customScrollableControl.Size = new System.Drawing.Size(845, 480);
            this.customScrollableControl.TabIndex = 0;
            this.customScrollableControl.Load += new System.EventHandler(this.customScrollableControl_Load);
            // 
            // tabControl
            // 
            this.tabControl.Controls.Add(this.basicImageOperations);
            this.tabControl.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.tabControl.Location = new System.Drawing.Point(0, 481);
            this.tabControl.Name = "tabControl";
            this.tabControl.SelectedIndex = 0;
            this.tabControl.Size = new System.Drawing.Size(844, 203);
            this.tabControl.TabIndex = 1;
            // 
            // basicImageOperations
            // 
            this.basicImageOperations.Controls.Add(this.rotateCClockButton);
            this.basicImageOperations.Controls.Add(this.flipHorizontalButton);
            this.basicImageOperations.Controls.Add(this.rotateClockButton);
            this.basicImageOperations.Controls.Add(this.flipVerticalButton);
            this.basicImageOperations.Controls.Add(this.cropImageButton);
            this.basicImageOperations.Location = new System.Drawing.Point(4, 25);
            this.basicImageOperations.Name = "basicImageOperations";
            this.basicImageOperations.Size = new System.Drawing.Size(836, 174);
            this.basicImageOperations.TabIndex = 0;
            this.basicImageOperations.Text = "Basic Image Operations";
            // 
            // rotateCClockButton
            // 
            this.rotateCClockButton.Image = ((System.Drawing.Image)(resources.GetObject("rotateCClockButton.Image")));
            this.rotateCClockButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.rotateCClockButton.Location = new System.Drawing.Point(307, 102);
            this.rotateCClockButton.Name = "rotateCClockButton";
            this.rotateCClockButton.Size = new System.Drawing.Size(163, 26);
            this.rotateCClockButton.TabIndex = 4;
            this.rotateCClockButton.Text = "Rotate CClockwise";
            this.rotateCClockButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.rotateCClockButton.Click += new System.EventHandler(this.rotateCClockButton_Click);
            // 
            // flipHorizontalButton
            // 
            this.flipHorizontalButton.Image = ((System.Drawing.Image)(resources.GetObject("flipHorizontalButton.Image")));
            this.flipHorizontalButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.flipHorizontalButton.Location = new System.Drawing.Point(154, 102);
            this.flipHorizontalButton.Name = "flipHorizontalButton";
            this.flipHorizontalButton.Size = new System.Drawing.Size(124, 26);
            this.flipHorizontalButton.TabIndex = 3;
            this.flipHorizontalButton.Text = "Flip Horizontal";
            this.flipHorizontalButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.flipHorizontalButton.Click += new System.EventHandler(this.flipHorizontalButton_Click);
            // 
            // rotateClockButton
            // 
            this.rotateClockButton.Image = ((System.Drawing.Image)(resources.GetObject("rotateClockButton.Image")));
            this.rotateClockButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.rotateClockButton.Location = new System.Drawing.Point(307, 55);
            this.rotateClockButton.Name = "rotateClockButton";
            this.rotateClockButton.Size = new System.Drawing.Size(163, 27);
            this.rotateClockButton.TabIndex = 2;
            this.rotateClockButton.Text = "Rotate Clockwise";
            this.rotateClockButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.rotateClockButton.Click += new System.EventHandler(this.rotateClockButton_Click);
            // 
            // flipVerticalButton
            // 
            this.flipVerticalButton.Image = ((System.Drawing.Image)(resources.GetObject("flipVerticalButton.Image")));
            this.flipVerticalButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.flipVerticalButton.Location = new System.Drawing.Point(154, 55);
            this.flipVerticalButton.Name = "flipVerticalButton";
            this.flipVerticalButton.Size = new System.Drawing.Size(124, 27);
            this.flipVerticalButton.TabIndex = 1;
            this.flipVerticalButton.Text = "Flip Vertical";
            this.flipVerticalButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.flipVerticalButton.Click += new System.EventHandler(this.flipVerticalButton_Click);
            // 
            // cropImageButton
            // 
            this.cropImageButton.Image = ((System.Drawing.Image)(resources.GetObject("cropImageButton.Image")));
            this.cropImageButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.cropImageButton.Location = new System.Drawing.Point(19, 55);
            this.cropImageButton.Name = "cropImageButton";
            this.cropImageButton.Size = new System.Drawing.Size(115, 27);
            this.cropImageButton.TabIndex = 0;
            this.cropImageButton.Text = "Crop Image";
            this.cropImageButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.cropImageButton.Click += new System.EventHandler(this.cropImageButton_Click);
            // 
            // PhotoEditorForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
            this.ClientSize = new System.Drawing.Size(844, 684);
            this.Controls.Add(this.tabControl);
            this.Controls.Add(this.customScrollableControl);
            this.Menu = this.MainMenu;
            this.Name = "PhotoEditorForm";
            this.Text = "Photo Editor Application";
            this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
            this.tabControl.ResumeLayout(false);
            this.basicImageOperations.ResumeLayout(false);
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new PhotoEditorForm());
		}

        private void OpenFile_Click(object sender, System.EventArgs e)
        {
            try
            {
                PictureObject.LoadImage();
                if(PictureObject.LoadedImage == null) 
                    throw(new Exception("Error, image could not beloaded"));
                DisplayImage();
            }
            catch(Exception exception)
            {
                ExceptionManager.Publish(exception);
            }

        }
        /// <summary>
        /// Method used to set the image displayed in the
        /// custom control to the current picture object image.
        /// Invalidates the custom control. 
        /// </summary>
        public void DisplayImage()
        {
           customScrollableControl.ScrollingImage = PictureObject.LoadedImage;
            customScrollableControl.Invalidate();
        }
        private void customScrollableControl_Load(object sender, System.EventArgs e)
        {
            DisplayImage();
        
        }

        /// <summary>
        /// Opens theCrop Dialog box window to allow the user to specify
        /// a new image size. The image will be cropped to the width and
        /// height where the cropped image is taken from the middle of the 
        /// original image.
        /// </summary>
        /// <param name="sender">A reference to the object calling this method</param>
        /// <param name="e">The event arguments provided by the event handler</param>
        private void cropImageButton_Click(object sender, System.EventArgs e)
        {
            try
            {
                CropDialog openDialog = new CropDialog(this);
                if(openDialog == null) 
                    throw(new Exception("Error, CropDialog could not be allocated"));
                openDialog.Show();
            }
            catch(Exception exception)
            {
                ExceptionManager.Publish(exception);
            }
        }
        
        /// <summary>
        /// Calls the RoatateFlipImage method of the Image class
        /// </summary>
        private void flipHorizontalButton_Click(object sender, System.EventArgs e)
        {
            try
            {
                PictureObject.RotateFlipImage(RotateFlipType.RotateNoneFlipX);
                DisplayImage();
            }
            catch(Exception exception)
            {
                ExceptionManager.Publish(exception);
            }
        
        }
        #region Do It Yourself Chapter 5
        /// <summary>
        /// Calls the RotateFlipImage method of the Image class
        /// </summary>
        private void flipVerticalButton_Click(object sender, System.EventArgs e)
        {
            try
            {
                PictureObject.RotateFlipImage(RotateFlipType.RotateNoneFlipY);
                DisplayImage();
            }
            catch(Exception exception)
            {
                ExceptionManager.Publish(exception);
            }
        }
        /// <summary>
        /// Calls the RotateFlipImage method of the Image class
        /// </summary>
        private void rotateClockButton_Click(object sender, System.EventArgs e)
        {
            try
            {
                PictureObject.RotateFlipImage(RotateFlipType.Rotate90FlipNone);
                DisplayImage();
            }
            catch(Exception exception)
            {
                ExceptionManager.Publish(exception);
            }
        
        }
        /// <summary>
        /// Calls the RotateFlipImage method of the Image class
        /// </summary>
        private void rotateCClockButton_Click(object sender, System.EventArgs e)
        {
            try
            {
                PictureObject.RotateFlipImage(RotateFlipType.Rotate270FlipNone);
                DisplayImage();
            }
            catch(Exception exception)
            {
                ExceptionManager.Publish(exception);
            }
        }
        #endregion
        /// <summary>
        /// Calls the SaveImage() method of the Image class
        /// </summary>
        private void saveMenu_Click(object sender, System.EventArgs e)
        {   
            try
            {
                PictureObject.SaveImage();
            }
            catch(Exception exception)
            {
                ExceptionManager.Publish(exception);
            }
        }
	}
}
